Index: uspace/lib/gfxfont/src/text.c
===================================================================
--- uspace/lib/gfxfont/src/text.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/gfxfont/src/text.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2022 Jiri Svoboda
  * All rights reserved.
  *
@@ -97,24 +97,39 @@
 /** Print string using text characters in text mode.
  *
- * @param font Font
  * @param pos Position of top-left corner of text
- * @param color Text color
+ * @param fmt Formatting
  * @param str String
  * @return EOK on success or an error code
  */
-static errno_t gfx_puttext_textmode(gfx_font_t *font, gfx_coord2_t *pos,
-    gfx_color_t *color, const char *str)
-{
-	gfx_context_t *gc = font->typeface->gc;
+static errno_t gfx_puttext_textmode(gfx_coord2_t *pos, gfx_text_fmt_t *fmt,
+    const char *str)
+{
+	gfx_context_t *gc = fmt->font->typeface->gc;
 	gfx_bitmap_params_t params;
 	gfx_bitmap_t *bitmap;
 	gfx_bitmap_alloc_t alloc;
+	gfx_coord_t width;
 	uint8_t attr;
 	pixelmap_t pmap;
 	gfx_coord_t x;
+	gfx_coord_t rmargin;
 	pixel_t pixel;
 	char32_t c;
 	size_t off;
+	bool ellipsis;
 	errno_t rc;
+
+	width = str_width(str);
+	if (fmt->abbreviate && width > fmt->width) {
+		ellipsis = true;
+		width = fmt->width;
+		if (width > 3)
+			rmargin = width - 3;
+		else
+			rmargin = width;
+	} else {
+		ellipsis = false;
+		rmargin = width;
+	}
 
 	/*
@@ -123,10 +138,10 @@
 	 */
 
-	gfx_color_get_ega(color, &attr);
+	gfx_color_get_ega(fmt->color, &attr);
 
 	gfx_bitmap_params_init(&params);
 	params.rect.p0.x = 0;
 	params.rect.p0.y = 0;
-	params.rect.p1.x = str_width(str);
+	params.rect.p1.x = width;
 	params.rect.p1.y = 1;
 
@@ -151,5 +166,5 @@
 
 	off = 0;
-	for (x = 0; x < params.rect.p1.x; x++) {
+	for (x = 0; x < rmargin; x++) {
 		c = str_decode(str, &off, STR_NO_LIMIT);
 		pixel = PIXEL(attr,
@@ -160,4 +175,15 @@
 	}
 
+	if (ellipsis) {
+		for (x = rmargin; x < params.rect.p1.x; x++) {
+			c = '.';
+			pixel = PIXEL(attr,
+			    (c >> 16) & 0xff,
+			    (c >> 8) & 0xff,
+			    c & 0xff);
+			pixelmap_put_pixel(&pmap, x, 0, pixel);
+		}
+	}
+
 	rc = gfx_bitmap_render(bitmap, NULL, pos);
 
@@ -168,5 +194,4 @@
 /** Get text starting position.
  *
- * @param font Font
  * @param pos Anchor position
  * @param fmt Text formatting
@@ -174,6 +199,6 @@
  * @param spos Place to store starting position
  */
-void gfx_text_start_pos(gfx_font_t *font, gfx_coord2_t *pos,
-    gfx_text_fmt_t *fmt, const char *str, gfx_coord2_t *spos)
+void gfx_text_start_pos(gfx_coord2_t *pos, gfx_text_fmt_t *fmt,
+    const char *str, gfx_coord2_t *spos)
 {
 	gfx_font_metrics_t fmetrics;
@@ -184,5 +209,9 @@
 	/* Adjust position for horizontal alignment */
 	if (fmt->halign != gfx_halign_left) {
-		width = gfx_text_width(font, str);
+		/* Compute text width */
+		width = gfx_text_width(fmt->font, str);
+		if (fmt->abbreviate && width > fmt->width)
+			width = fmt->width;
+
 		switch (fmt->halign) {
 		case gfx_halign_center:
@@ -198,5 +227,5 @@
 
 	/* Adjust position for vertical alignment */
-	gfx_font_get_metrics(font, &fmetrics);
+	gfx_font_get_metrics(fmt->font, &fmetrics);
 
 	if (fmt->valign != gfx_valign_baseline) {
@@ -219,5 +248,4 @@
 /** Render text.
  *
- * @param font Font
  * @param pos Anchor position
  * @param fmt Text formatting
@@ -225,27 +253,44 @@
  * @return EOK on success or an error code
  */
-errno_t gfx_puttext(gfx_font_t *font, gfx_coord2_t *pos,
-    gfx_text_fmt_t *fmt, const char *str)
+errno_t gfx_puttext(gfx_coord2_t *pos, gfx_text_fmt_t *fmt, const char *str)
 {
 	gfx_glyph_metrics_t gmetrics;
+	gfx_font_metrics_t fmetrics;
 	size_t stradv;
 	const char *cp;
 	gfx_glyph_t *glyph;
 	gfx_coord2_t cpos;
+	gfx_coord2_t spos;
+	gfx_rect_t rect;
+	gfx_coord_t width;
+	gfx_coord_t rmargin;
+	bool ellipsis;
 	errno_t rc;
 
-	gfx_text_start_pos(font, pos, fmt, str, &cpos);
+	gfx_text_start_pos(pos, fmt, str, &spos);
 
 	/* Text mode */
-	if ((font->finfo->props.flags & gff_text_mode) != 0)
-		return gfx_puttext_textmode(font, &cpos, fmt->color, str);
-
-	rc = gfx_set_color(font->typeface->gc, fmt->color);
+	if ((fmt->font->finfo->props.flags & gff_text_mode) != 0)
+		return gfx_puttext_textmode(&spos, fmt, str);
+
+	rc = gfx_set_color(fmt->font->typeface->gc, fmt->color);
 	if (rc != EOK)
 		return rc;
 
+	width = gfx_text_width(fmt->font, str);
+
+	if (fmt->abbreviate && width > fmt->width) {
+		/* Need to append ellipsis */
+		ellipsis = true;
+		rmargin = spos.x + fmt->width - gfx_text_width(fmt->font, "...");
+	} else {
+		ellipsis = false;
+		rmargin = spos.x + width;
+	}
+
+	cpos = spos;
 	cp = str;
 	while (*cp != '\0') {
-		rc = gfx_font_search_glyph(font, cp, &glyph, &stradv);
+		rc = gfx_font_search_glyph(fmt->font, cp, &glyph, &stradv);
 		if (rc != EOK) {
 			++cp;
@@ -255,4 +300,8 @@
 		gfx_glyph_get_metrics(glyph, &gmetrics);
 
+		/* Stop if we would run over the right margin */
+		if (fmt->abbreviate && cpos.x + gmetrics.advance > rmargin)
+			break;
+
 		rc = gfx_glyph_render(glyph, &cpos);
 		if (rc != EOK)
@@ -263,4 +312,43 @@
 	}
 
+	/* Text underlining */
+	if (fmt->underline) {
+		gfx_font_get_metrics(fmt->font, &fmetrics);
+
+		rect.p0.x = spos.x;
+		rect.p0.y = spos.y + fmetrics.underline_y0;
+		rect.p1.x = cpos.x;
+		rect.p1.y = spos.y + fmetrics.underline_y1;
+
+		rc = gfx_fill_rect(fmt->font->typeface->gc, &rect);
+		if (rc != EOK)
+			return rc;
+	}
+
+	/* Render ellipsis, if required */
+	if (ellipsis) {
+		rc = gfx_font_search_glyph(fmt->font, ".", &glyph, &stradv);
+		if (rc != EOK)
+			return EOK;
+
+		gfx_glyph_get_metrics(glyph, &gmetrics);
+
+		rc = gfx_glyph_render(glyph, &cpos);
+		if (rc != EOK)
+			return rc;
+
+		cpos.x += gmetrics.advance;
+
+		rc = gfx_glyph_render(glyph, &cpos);
+		if (rc != EOK)
+			return rc;
+
+		cpos.x += gmetrics.advance;
+
+		rc = gfx_glyph_render(glyph, &cpos);
+		if (rc != EOK)
+			return rc;
+	}
+
 	return EOK;
 }
@@ -268,5 +356,4 @@
 /** Find character position in string by X coordinate.
  *
- * @param font Font
  * @param pos Anchor position
  * @param fmt Text formatting
@@ -280,6 +367,6 @@
  *         offset of the following character.
  */
-size_t gfx_text_find_pos(gfx_font_t *font, gfx_coord2_t *pos,
-    gfx_text_fmt_t *fmt, const char *str, gfx_coord2_t *fpos)
+size_t gfx_text_find_pos(gfx_coord2_t *pos, gfx_text_fmt_t *fmt,
+    const char *str, gfx_coord2_t *fpos)
 {
 	gfx_glyph_metrics_t gmetrics;
@@ -292,8 +379,8 @@
 	errno_t rc;
 
-	gfx_text_start_pos(font, pos, fmt, str, &cpos);
+	gfx_text_start_pos(pos, fmt, str, &cpos);
 
 	/* Text mode */
-	if ((font->finfo->props.flags & gff_text_mode) != 0) {
+	if ((fmt->font->finfo->props.flags & gff_text_mode) != 0) {
 		off = 0;
 		strsize = str_size(str);
@@ -311,5 +398,5 @@
 	off = 0;
 	while (*cp != '\0') {
-		rc = gfx_font_search_glyph(font, cp, &glyph, &stradv);
+		rc = gfx_font_search_glyph(fmt->font, cp, &glyph, &stradv);
 		if (rc != EOK) {
 			++cp;
@@ -337,5 +424,4 @@
  * to the same objects, respectively.
  *
- * @param font Font
  * @param pos Anchor position
  * @param fmt Text formatting
@@ -344,7 +430,6 @@
  * @param cfmt Place to store format for continuation
  */
-void gfx_text_cont(gfx_font_t *font, gfx_coord2_t *pos,
-    gfx_text_fmt_t *fmt, const char *str, gfx_coord2_t *cpos,
-    gfx_text_fmt_t *cfmt)
+void gfx_text_cont(gfx_coord2_t *pos, gfx_text_fmt_t *fmt, const char *str,
+    gfx_coord2_t *cpos, gfx_text_fmt_t *cfmt)
 {
 	gfx_coord2_t spos;
@@ -352,6 +437,6 @@
 
 	/* Continuation should start where the current string ends */
-	gfx_text_start_pos(font, pos, fmt, str, &spos);
-	cpos->x = spos.x + gfx_text_width(font, str);
+	gfx_text_start_pos(pos, fmt, str, &spos);
+	cpos->x = spos.x + gfx_text_width(fmt->font, str);
 	cpos->y = spos.y;
 
@@ -364,4 +449,7 @@
 	tfmt.valign = gfx_valign_baseline;
 
+	/* Remaining available width */
+	tfmt.width = fmt->width - (cpos->x - spos.x);
+
 	*cfmt = tfmt;
 }
@@ -369,5 +457,4 @@
 /** Get text bounding rectangle.
  *
- * @param font Font
  * @param pos Anchor position
  * @param fmt Text formatting
@@ -375,15 +462,19 @@
  * @param rect Place to store bounding rectangle
  */
-void gfx_text_rect(gfx_font_t *font, gfx_coord2_t *pos,
-    gfx_text_fmt_t *fmt, const char *str, gfx_rect_t *rect)
+void gfx_text_rect(gfx_coord2_t *pos, gfx_text_fmt_t *fmt, const char *str,
+    gfx_rect_t *rect)
 {
 	gfx_coord2_t spos;
-
-	gfx_text_start_pos(font, pos, fmt, str, &spos);
+	gfx_coord_t width;
+
+	gfx_text_start_pos(pos, fmt, str, &spos);
+	width = gfx_text_width(fmt->font, str);
+	if (fmt->abbreviate && width > fmt->width)
+		width = fmt->width;
 
 	rect->p0.x = spos.x;
-	rect->p0.y = spos.y - font->metrics.ascent;
-	rect->p1.x = spos.x + gfx_text_width(font, str);
-	rect->p1.y = spos.y + font->metrics.descent + 1;
+	rect->p0.y = spos.y - fmt->font->metrics.ascent;
+	rect->p1.x = spos.x + width;
+	rect->p1.y = spos.y +  fmt->font->metrics.descent + 1;
 }
 
Index: uspace/lib/gfxfont/test/text.c
===================================================================
--- uspace/lib/gfxfont/test/text.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/gfxfont/test/text.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -135,9 +135,10 @@
 
 	gfx_text_fmt_init(&fmt);
+	fmt.font = font;
 	fmt.color = color;
 	pos.x = 0;
 	pos.y = 0;
 
-	rc = gfx_puttext(font, &pos, &fmt, "Hello world!");
+	rc = gfx_puttext(&pos, &fmt, "Hello world!");
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -181,9 +182,10 @@
 
 	gfx_text_fmt_init(&fmt);
+	fmt.font = font;
 	fmt.color = color;
 	pos.x = 0;
 	pos.y = 0;
 
-	rc = gfx_puttext(font, &pos, &fmt, "Hello world!");
+	rc = gfx_puttext(&pos, &fmt, "Hello world!");
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
@@ -245,4 +247,5 @@
 
 	gfx_text_fmt_init(&fmt);
+	fmt.font = font;
 	anchor.x = 10;
 	anchor.y = 0;
@@ -250,35 +253,35 @@
 	fpos.x = 9;
 	fpos.y = 0;
-	off = gfx_text_find_pos(font, &anchor, &fmt, "Aii", &fpos);
+	off = gfx_text_find_pos(&anchor, &fmt, "Aii", &fpos);
 	PCUT_ASSERT_INT_EQUALS(0, off);
 
 	fpos.x = 10;
 	fpos.y = 0;
-	off = gfx_text_find_pos(font, &anchor, &fmt, "Aii", &fpos);
+	off = gfx_text_find_pos(&anchor, &fmt, "Aii", &fpos);
 	PCUT_ASSERT_INT_EQUALS(0, off);
 
 	fpos.x = 11;
 	fpos.y = 0;
-	off = gfx_text_find_pos(font, &anchor, &fmt, "Aii", &fpos);
+	off = gfx_text_find_pos(&anchor, &fmt, "Aii", &fpos);
 	PCUT_ASSERT_INT_EQUALS(0, off);
 
 	fpos.x = 19;
 	fpos.y = 0;
-	off = gfx_text_find_pos(font, &anchor, &fmt, "Aii", &fpos);
+	off = gfx_text_find_pos(&anchor, &fmt, "Aii", &fpos);
 	PCUT_ASSERT_INT_EQUALS(1, off);
 
 	fpos.x = 20;
 	fpos.y = 0;
-	off = gfx_text_find_pos(font, &anchor, &fmt, "Aii", &fpos);
+	off = gfx_text_find_pos(&anchor, &fmt, "Aii", &fpos);
 	PCUT_ASSERT_INT_EQUALS(2, off);
 
 	fpos.x = 21;
 	fpos.y = 0;
-	off = gfx_text_find_pos(font, &anchor, &fmt, "Aii", &fpos);
+	off = gfx_text_find_pos(&anchor, &fmt, "Aii", &fpos);
 	PCUT_ASSERT_INT_EQUALS(3, off);
 
 	fpos.x = 22;
 	fpos.y = 0;
-	off = gfx_text_find_pos(font, &anchor, &fmt, "Aii", &fpos);
+	off = gfx_text_find_pos(&anchor, &fmt, "Aii", &fpos);
 	PCUT_ASSERT_INT_EQUALS(3, off);
 
@@ -318,33 +321,34 @@
 	anchor.y = 0;
 	gfx_text_fmt_init(&fmt);
+	fmt.font = font;
 
 	fpos.x = 9;
 	fpos.y = 0;
-	off = gfx_text_find_pos(font, &anchor, &fmt, "Abc", &fpos);
+	off = gfx_text_find_pos(&anchor, &fmt, "Abc", &fpos);
 	PCUT_ASSERT_INT_EQUALS(0, off);
 
 	fpos.x = 10;
 	fpos.y = 0;
-	off = gfx_text_find_pos(font, &anchor, &fmt, "Abc", &fpos);
+	off = gfx_text_find_pos(&anchor, &fmt, "Abc", &fpos);
 	PCUT_ASSERT_INT_EQUALS(0, off);
 
 	fpos.x = 11;
 	fpos.y = 0;
-	off = gfx_text_find_pos(font, &anchor, &fmt, "Abc", &fpos);
+	off = gfx_text_find_pos(&anchor, &fmt, "Abc", &fpos);
 	PCUT_ASSERT_INT_EQUALS(1, off);
 
 	fpos.x = 12;
 	fpos.y = 0;
-	off = gfx_text_find_pos(font, &anchor, &fmt, "Abc", &fpos);
+	off = gfx_text_find_pos(&anchor, &fmt, "Abc", &fpos);
 	PCUT_ASSERT_INT_EQUALS(2, off);
 
 	fpos.x = 13;
 	fpos.y = 0;
-	off = gfx_text_find_pos(font, &anchor, &fmt, "Abc", &fpos);
+	off = gfx_text_find_pos(&anchor, &fmt, "Abc", &fpos);
 	PCUT_ASSERT_INT_EQUALS(3, off);
 
 	fpos.x = 14;
 	fpos.y = 0;
-	off = gfx_text_find_pos(font, &anchor, &fmt, "Abc", &fpos);
+	off = gfx_text_find_pos(&anchor, &fmt, "Abc", &fpos);
 	PCUT_ASSERT_INT_EQUALS(3, off);
 
@@ -385,7 +389,8 @@
 	anchor.y = 20;
 	gfx_text_fmt_init(&fmt);
+	fmt.font = font;
 	fmt.color = color;
 
-	gfx_text_cont(font, &anchor, &fmt, "Abc", &cpos, &cfmt);
+	gfx_text_cont(&anchor, &fmt, "Abc", &cpos, &cfmt);
 
 	PCUT_ASSERT_INT_EQUALS(13, cpos.x);
@@ -431,7 +436,8 @@
 	anchor.y = 20;
 	gfx_text_fmt_init(&fmt);
+	fmt.font = font;
 	fmt.color = color;
 
-	gfx_text_rect(font, &anchor, &fmt, "Abc", &rect);
+	gfx_text_rect(&anchor, &fmt, "Abc", &rect);
 
 	PCUT_ASSERT_INT_EQUALS(10, rect.p0.x);
Index: uspace/lib/gfxfont/test/tpf.c
===================================================================
--- uspace/lib/gfxfont/test/tpf.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/gfxfont/test/tpf.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -73,7 +73,8 @@
 } testgc_bitmap_t;
 
+static const gfx_font_flags_t test_font_flags = gff_bold_italic;
+
 enum {
 	test_font_size = 9,
-	test_font_flags = gff_bold_italic,
 	test_font_ascent = 4,
 	test_font_descent = 3,
Index: uspace/lib/gfximage/include/gfximage/tga.h
===================================================================
--- uspace/lib/gfximage/include/gfximage/tga.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/gfximage/include/gfximage/tga.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -29,5 +29,5 @@
  */
 
-/** @addtogroup draw
+/** @addtogroup libgfximage
  * @{
  */
Index: uspace/lib/gfximage/include/gfximage/tga_gz.h
===================================================================
--- uspace/lib/gfximage/include/gfximage/tga_gz.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/gfximage/include/gfximage/tga_gz.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -29,5 +29,5 @@
  */
 
-/** @addtogroup draw
+/** @addtogroup libgfximage
  * @{
  */
Index: uspace/lib/gfximage/src/tga.c
===================================================================
--- uspace/lib/gfximage/src/tga.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/gfximage/src/tga.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -28,5 +28,5 @@
  */
 
-/** @addtogroup draw
+/** @addtogroup libgfximage
  * @{
  */
Index: uspace/lib/gfximage/src/tga_gz.c
===================================================================
--- uspace/lib/gfximage/src/tga_gz.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/gfximage/src/tga_gz.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup draw
+/** @addtogroup libgfximage
  * @{
  */
Index: uspace/lib/hound/src/protocol.c
===================================================================
--- uspace/lib/hound/src/protocol.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/hound/src/protocol.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2023 Jiri Svoboda
  * Copyright (c) 2012 Jan Vesely
  * All rights reserved.
@@ -84,4 +85,7 @@
 const char *HOUND_SERVICE = "audio/hound";
 
+/** Server object */
+static loc_srv_t *hound_srv;
+
 /**
  * Start a new audio session.
@@ -730,12 +734,23 @@
 errno_t hound_server_register(const char *name, service_id_t *id)
 {
+	errno_t rc;
+
 	if (!name || !id)
 		return EINVAL;
 
-	errno_t ret = loc_server_register(name);
-	if (ret != EOK)
-		return ret;
-
-	return loc_service_register(HOUND_SERVICE, id);
+	if (hound_srv != NULL)
+		return EBUSY;
+
+	rc = loc_server_register(name, &hound_srv);
+	if (rc != EOK)
+		return rc;
+
+	rc = loc_service_register(hound_srv, HOUND_SERVICE, id);
+	if (rc != EOK) {
+		loc_server_unregister(hound_srv);
+		return rc;
+	}
+
+	return EOK;
 }
 
@@ -746,5 +761,6 @@
 void hound_server_unregister(service_id_t id)
 {
-	loc_service_unregister(id);
+	loc_service_unregister(hound_srv, id);
+	loc_server_unregister(hound_srv);
 }
 
Index: uspace/lib/inet/meson.build
===================================================================
--- uspace/lib/inet/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2021 Jiri Svoboda
+# Copyright (c) 2024 Jiri Svoboda
 # All rights reserved.
 #
@@ -46,4 +46,5 @@
 
 test_src = files(
+	'test/addr.c',
 	'test/eth_addr.c',
 	'test/main.c',
Index: uspace/lib/inet/src/addr.c
===================================================================
--- uspace/lib/inet/src/addr.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/src/addr.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2013 Martin Decky
  * All rights reserved.
@@ -379,6 +379,9 @@
 				wildcard_size = 16 - i;
 				cur = gend + 2;
+				continue;
 			}
 		}
+
+		cur = gend + 1;
 	}
 
Index: uspace/lib/inet/src/iplink_srv.c
===================================================================
--- uspace/lib/inet/src/iplink_srv.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/src/iplink_srv.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -74,6 +74,9 @@
 
 	rc = async_data_read_finalize(&call, &mac, size);
-	if (rc != EOK)
-		async_answer_0(&call, rc);
+	if (rc != EOK) {
+		async_answer_0(&call, rc);
+		async_answer_0(icall, rc);
+		return;
+	}
 
 	async_answer_0(icall, rc);
@@ -94,4 +97,5 @@
 	rc = srv->ops->set_mac48(srv, &mac);
 	if (rc != EOK) {
+		async_answer_0(&call, rc);
 		async_answer_0(icall, rc);
 		return;
@@ -99,6 +103,9 @@
 
 	rc = async_data_read_finalize(&call, &mac, sizeof(eth_addr_t));
-	if (rc != EOK)
-		async_answer_0(&call, rc);
+	if (rc != EOK) {
+		async_answer_0(&call, rc);
+		async_answer_0(icall, rc);
+		return;
+	}
 
 	async_answer_0(icall, rc);
@@ -109,4 +116,5 @@
 	ipc_call_t call;
 	size_t size;
+
 	if (!async_data_write_receive(&call, &size)) {
 		async_answer_0(&call, EREFUSED);
@@ -126,4 +134,5 @@
 		async_answer_0(&call, rc);
 		async_answer_0(icall, rc);
+		return;
 	}
 
@@ -136,4 +145,5 @@
 	ipc_call_t call;
 	size_t size;
+
 	if (!async_data_write_receive(&call, &size)) {
 		async_answer_0(&call, EREFUSED);
@@ -153,4 +163,5 @@
 		async_answer_0(&call, rc);
 		async_answer_0(icall, rc);
+		return;
 	}
 
@@ -181,7 +192,7 @@
 {
 	iplink_sdu6_t sdu;
-
-	ipc_call_t call;
-	size_t size;
+	ipc_call_t call;
+	size_t size;
+
 	if (!async_data_write_receive(&call, &size)) {
 		async_answer_0(&call, EREFUSED);
Index: uspace/lib/inet/src/udp.c
===================================================================
--- uspace/lib/inet/src/udp.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/src/udp.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -256,7 +256,14 @@
 {
 	async_exch_t *exch;
+	inet_ep_t ddest;
 
 	exch = async_exchange_begin(assoc->udp->sess);
 	aid_t req = async_send_1(exch, UDP_ASSOC_SEND_MSG, assoc->id, NULL);
+
+	/* If dest is null, use default destination */
+	if (dest == NULL) {
+		inet_ep_init(&ddest);
+		dest = &ddest;
+	}
 
 	errno_t rc = async_data_write_start(exch, (void *)dest,
Index: uspace/lib/inet/test/addr.c
===================================================================
--- uspace/lib/inet/test/addr.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/inet/test/addr.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,199 @@
+/*
+ * Copyright (c) 2024 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <errno.h>
+#include <inet/addr.h>
+#include <pcut/pcut.h>
+
+PCUT_INIT;
+
+PCUT_TEST_SUITE(addr);
+
+/** Test inet_addr_parse() with unabbreviated address */
+PCUT_TEST(inet_addr_parse_full)
+{
+	errno_t rc;
+	inet_addr_t addr;
+	char *endptr;
+
+	rc = inet_addr_parse("1122:3344:5566:7788:99aa:bbcc:ddee:ff00/", &addr,
+	    &endptr);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_EQUALS('/', *endptr);
+
+	PCUT_ASSERT_INT_EQUALS(ip_v6, addr.version);
+
+	PCUT_ASSERT_INT_EQUALS(0x11, addr.addr6[0]);
+	PCUT_ASSERT_INT_EQUALS(0x22, addr.addr6[1]);
+	PCUT_ASSERT_INT_EQUALS(0x33, addr.addr6[2]);
+	PCUT_ASSERT_INT_EQUALS(0x44, addr.addr6[3]);
+	PCUT_ASSERT_INT_EQUALS(0x55, addr.addr6[4]);
+	PCUT_ASSERT_INT_EQUALS(0x66, addr.addr6[5]);
+	PCUT_ASSERT_INT_EQUALS(0x77, addr.addr6[6]);
+	PCUT_ASSERT_INT_EQUALS(0x88, addr.addr6[7]);
+
+	PCUT_ASSERT_INT_EQUALS(0x99, addr.addr6[8]);
+	PCUT_ASSERT_INT_EQUALS(0xaa, addr.addr6[9]);
+	PCUT_ASSERT_INT_EQUALS(0xbb, addr.addr6[10]);
+	PCUT_ASSERT_INT_EQUALS(0xcc, addr.addr6[11]);
+	PCUT_ASSERT_INT_EQUALS(0xdd, addr.addr6[12]);
+	PCUT_ASSERT_INT_EQUALS(0xee, addr.addr6[13]);
+	PCUT_ASSERT_INT_EQUALS(0xff, addr.addr6[14]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[15]);
+}
+
+/** Test inet_addr_parse() with short groups (< 0x1000) */
+PCUT_TEST(inet_addr_parse_shortgr)
+{
+	errno_t rc;
+	inet_addr_t addr;
+	char *endptr;
+
+	rc = inet_addr_parse("1:22:333:4444:5:66:777:8888/", &addr,
+	    &endptr);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_EQUALS('/', *endptr);
+
+	PCUT_ASSERT_INT_EQUALS(ip_v6, addr.version);
+
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[0]);
+	PCUT_ASSERT_INT_EQUALS(0x01, addr.addr6[1]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[2]);
+	PCUT_ASSERT_INT_EQUALS(0x22, addr.addr6[3]);
+	PCUT_ASSERT_INT_EQUALS(0x03, addr.addr6[4]);
+	PCUT_ASSERT_INT_EQUALS(0x33, addr.addr6[5]);
+	PCUT_ASSERT_INT_EQUALS(0x44, addr.addr6[6]);
+	PCUT_ASSERT_INT_EQUALS(0x44, addr.addr6[7]);
+
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[8]);
+	PCUT_ASSERT_INT_EQUALS(0x05, addr.addr6[9]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[10]);
+	PCUT_ASSERT_INT_EQUALS(0x66, addr.addr6[11]);
+	PCUT_ASSERT_INT_EQUALS(0x07, addr.addr6[12]);
+	PCUT_ASSERT_INT_EQUALS(0x77, addr.addr6[13]);
+	PCUT_ASSERT_INT_EQUALS(0x88, addr.addr6[14]);
+	PCUT_ASSERT_INT_EQUALS(0x88, addr.addr6[15]);
+}
+
+/** Test inet_addr_parse() with wildcard at the beginning */
+PCUT_TEST(inet_addr_parse_wcbegin)
+{
+	errno_t rc;
+	inet_addr_t addr;
+	char *endptr;
+
+	rc = inet_addr_parse("::1234/", &addr, &endptr);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_EQUALS('/', *endptr);
+
+	PCUT_ASSERT_INT_EQUALS(ip_v6, addr.version);
+
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[0]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[1]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[2]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[3]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[4]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[5]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[6]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[7]);
+
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[8]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[9]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[10]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[11]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[12]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[13]);
+	PCUT_ASSERT_INT_EQUALS(0x12, addr.addr6[14]);
+	PCUT_ASSERT_INT_EQUALS(0x34, addr.addr6[15]);
+}
+
+/** Test inet_addr_parse() with wildcard in the middle */
+PCUT_TEST(inet_addr_parse_wcmiddle)
+{
+	errno_t rc;
+	inet_addr_t addr;
+	char *endptr;
+
+	rc = inet_addr_parse("1122:3344::5566/", &addr, &endptr);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_EQUALS('/', *endptr);
+
+	PCUT_ASSERT_INT_EQUALS(ip_v6, addr.version);
+
+	PCUT_ASSERT_INT_EQUALS(0x11, addr.addr6[0]);
+	PCUT_ASSERT_INT_EQUALS(0x22, addr.addr6[1]);
+	PCUT_ASSERT_INT_EQUALS(0x33, addr.addr6[2]);
+	PCUT_ASSERT_INT_EQUALS(0x44, addr.addr6[3]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[4]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[5]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[6]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[7]);
+
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[8]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[9]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[10]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[11]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[12]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[13]);
+	PCUT_ASSERT_INT_EQUALS(0x55, addr.addr6[14]);
+	PCUT_ASSERT_INT_EQUALS(0x66, addr.addr6[15]);
+}
+
+/** Test inet_addr_parse() with wildcard at the end */
+PCUT_TEST(inet_addr_parse_wcend)
+{
+	errno_t rc;
+	inet_addr_t addr;
+	char *endptr;
+
+	rc = inet_addr_parse("1234:5678::/", &addr, &endptr);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_EQUALS('/', *endptr);
+
+	PCUT_ASSERT_INT_EQUALS(ip_v6, addr.version);
+
+	PCUT_ASSERT_INT_EQUALS(0x12, addr.addr6[0]);
+	PCUT_ASSERT_INT_EQUALS(0x34, addr.addr6[1]);
+	PCUT_ASSERT_INT_EQUALS(0x56, addr.addr6[2]);
+	PCUT_ASSERT_INT_EQUALS(0x78, addr.addr6[3]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[4]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[5]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[6]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[7]);
+
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[8]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[9]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[10]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[11]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[12]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[13]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[14]);
+	PCUT_ASSERT_INT_EQUALS(0x00, addr.addr6[15]);
+}
+
+PCUT_EXPORT(addr);
Index: uspace/lib/inet/test/main.c
===================================================================
--- uspace/lib/inet/test/main.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/inet/test/main.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -31,4 +31,5 @@
 PCUT_INIT;
 
+PCUT_IMPORT(addr);
 PCUT_IMPORT(eth_addr);
 
Index: uspace/lib/input/doc/doxygroups.h
===================================================================
--- uspace/lib/input/doc/doxygroups.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/input/doc/doxygroups.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,3 @@
+/** @addtogroup libinput libinput
+ * @ingroup libs
+ */
Index: uspace/lib/input/include/io/input.h
===================================================================
--- uspace/lib/input/include/io/input.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/input/include/io/input.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,68 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libinput
+ * @{
+ */
+/** @file
+ */
+
+#ifndef _LIBINPUT_INPUT_H_
+#define _LIBINPUT_INPUT_H_
+
+#include <async.h>
+#include <io/kbd_event.h>
+
+struct input_ev_ops;
+
+typedef struct {
+	async_sess_t *sess;
+	struct input_ev_ops *ev_ops;
+	void *user;
+} input_t;
+
+typedef struct input_ev_ops {
+	errno_t (*active)(input_t *);
+	errno_t (*deactive)(input_t *);
+	errno_t (*key)(input_t *, unsigned, kbd_event_type_t, keycode_t,
+	    keymod_t, char32_t);
+	errno_t (*move)(input_t *, unsigned, int, int);
+	errno_t (*abs_move)(input_t *, unsigned, unsigned, unsigned, unsigned,
+	    unsigned);
+	errno_t (*button)(input_t *, unsigned, int, int);
+	errno_t (*dclick)(input_t *, unsigned, int);
+} input_ev_ops_t;
+
+extern errno_t input_open(async_sess_t *, input_ev_ops_t *, void *, input_t **);
+extern void input_close(input_t *);
+extern errno_t input_activate(input_t *);
+
+#endif
+
+/** @}
+ */
